#!/bin/sh
## -----------------------------------------
## Impose to read the script with bash
## -----------------------------------------
#$ -S /bin/bash
##------------------------------------------
##Choose the queue you want to submit your job to
##------------------------------------------
#$ -q 4_8_16_viper
## -----------------------------------------
## Replace NPROC by the desired number of processors
## -----------------------------------------
#$ -pe openmpi 8
## -----------------------------------------
## Name of the run
## -----------------------------------------
#$ -N GENE
##------------------------------------------
## Define the local directory, in case it is needed.
##------------------------------------------
MYDIR=`pwd`
## -----------------------------------------
## export the variable MPIR_HOME which needs to be 
## defined in the .bash_profile or .tcshrc.
## -----------------------------------------
##MPIR_HOME=/opt/openmpi_1.3.3
MPIR_HOME=/home/malbrech/malbrech/INSTALL_PERSO/openmpi-1.4.1
#$ -v MPIR_HOME
## -----------------------------------------
## Change directory to this job's working directory
## -----------------------------------------
#$ -cwd
## -----------------------------------------
## Echo  Start time and present Direcory
## -----------------------------------------
echo Start time is `date`
echo Directory is `pwd`

export MKL_SERIAL=yes
export OMP_NUM_THREADS=1

## -----------------------------------------
## Run the executable
## -----------------------------------------

##$MPIR_HOME/bin/mpiexec -np $NSLOTS ./gene
mpirun  -np $NSLOTS ./gene_Cobra

### to submit a parameter scan, comment the previous line and uncomment
### the following (see GENE documentation or ./scanscript --help)
#./scanscript --np $NSLOTS --ppn 1

## -----------------------------------------
## Echo end time
## -----------------------------------------
echo End time is `date`
