#!/bin/sh

# @ job_name = GENE
# @ comment = "Example BG/P Job"

# ## Blue Gene job
# @ job_type = bluegene

# @ error = $(job_name)_$(jobid).err
# @ output = $(job_name)_$(jobid).out
# @ environment = COPY_ALL;

# ## Syntax: wall_clock_limit = <hardlimit,softlimit>
# ##   [[hours:]minutes:]seconds[.fraction]
# @ wall_clock_limit = 1:00:00

# ## Syntax: notification = always|error|start|never|complete
# ##   where:
# ##   - always : Notify the user when the job begins, ends,
# ##     or if it incurs error conditions.
# ##   - error : Notify the user only if the job fails.
# ##   - start : Notify the user only when the job begins.
# ##   - never : Never notify the user.
# ##   - complete : Notify the user only when the job ends.
# ## Default value: complete 
# @ notification = always
# @ notify_user = $USER@epfl.ch

# ## Syntax:  class = short|prod|mid
# @ class = prod

# ## Syntax: bg_size = number_of_nodes
# @ bg_size = 1024
# ## Syntax: bg_connection = TORUS | PREFER_TORUS | MESH
# @ bg_connection = TORUS

# @ queue

mpirun ./gene_cadmos_bgp

### to submit a parameter scan, comment the previous line and uncomment
### the following (see GENE documentation or ./scanscript --help)
#./scanscript --np 4096 --ppn 1 --mps 4
