#!/bin/sh
#PBS -l walltime=0:20:00
#PBS -l nodes=1:ppn=4
#PBS -M $(MAILADDRESS)
#PBS -mae

DIAGDIR=setfromparfile
CHPTDIR=setfromparfile

NPES=$(cat $PBS_NODEFILE|wc -l)
let RANK_MAX=NPES-1
WK=/spare/$USER

mkdir -p $CHPTDIR
mkdir -p $DIAGDIR
mpiexec mkdir -p $WK
mpiexec rm -f $WK/\*

rm -f $DIAGDIR/*.dat
rm -f $DIAGDIR/*.tmp

echo now copying the checkpoint files
#
#   Copy all files required for restart
#   from SCRATCH
#
#cd $SCR
#find . -maxdepth 1 -type f -exec cp -p {} $WK/  \;
#cd $WK
#dat=$(printf "dat%d" $(cat datn))     # to WK dir
#mkdir -p $WK/$dat
for r in `seq 0 $RANK_MAX`; do
    f=$(printf "$CHPTDIR/chpt.%4.4d" $r)
    pbsdsh -n $r -- cp -a $f $WK
done
echo copying done, starting the gene code

export OMP_NUM_THREADS=1
cat $PBS_NODEFILE
cd $PBS_O_WORKDIR
mpiexec -kill ./gene_crpp_cluster
echo done


mpiexec cp -a $WK/chpt.\* $CHPTDIR
mpiexec rm -f $WK/chpt.\*
mpiexec cp -a $WK/\* $DIAGDIR
mpiexec rm -f $WK/\*
