#!/bin/bash --login
### this is a submit script for job submission from the Launcher on the XT6 part of Hector
### MAXWT 12
### PROCSPERNODE 24
### SUBMITCMD qsub

#PBS -N JOBNAME
##
## request the total number of MPI processes available for your job:
#PBS -l mppwidth=NMPIPROCS
##
## Tell the scheduler how many processes to place on a XT node. 
## (Valid choices for XT4 nodes: 1, 2, 3 or 4 and for the XT6 nodes: 1 to 24.)
## Budget will be charged for the number of nodes reserved!!
#PBS -l mppnppn=PPN
##
#PBS -l walltime=WALLTIME
##
## Specify the budget your job is going to be charged to:
#PBS -A budget               
## (e.g., hpx1fipp for the DEISA 2010 project)
  
# Change to the directory that the job was submitted from
cd $PBS_O_WORKDIR

#number of OpenMP threads
export OMP_NUM_THREADS=1

aprun -n NMPIPROCS -N PPN ./gene_hector
