#!/bin/bash --login
#PBS -N GENE
##
## request the total number of MPI processes available for your job:
#PBS -l mppwidth= 528
##
## Tell the scheduler how many processes to place on a XT node. 
## (Valid choices for XT4 nodes: 1, 2, 3 or 4 and for the XT6 nodes: 1 to 24.)
## Budget will be charged for the number of nodes reserved!!
#PBS -l mppnppn=24
##
#PBS -l walltime=00:20:00
##
## Specify the budget your job is going to be charged to:
#PBS -A budget               
## (e.g., hpx1fipp for the DEISA 2010 project)
  
# Change to the directory that the job was submitted from
cd $PBS_O_WORKDIR

#number of OpenMP threads
export OMP_NUM_THREADS=1

# Launch the parallel job
export NPROC=`qstat -f $PBS_JOBID | awk '/mppwidth/ {print $3}'`
export NTASK=`qstat -f $PBS_JOBID | awk '/mppnppn/  {print $3}'`

aprun -n $NPROC -N $NTASK ./gene_hector
