###########################################################################
### Master file for gene, JAC version                                   ###
###########################################################################

###########################################################################
### Compiler and linker                                                 ###
###########################################################################

COMPTYPE = PORTLAND

#--------------------------------------------------------------------------

PRECISION = double
OPENMP = no
FFTLIB = fftw

# switching on extensive debugging -- slows down the code significantly
DEBUG = no
# switching on just source including and traceback -- code is still fast
# enough for doing longer runs
SOURCEINC = no
# switching on slepc/petsc for eigenvalue calculation (not yet verified)
SLEPC = no


#--------------------------------------------------------------------------

FFLAGS = -I$(OBJDIR) -I. -I$(SRCDIR) 

ifeq ($(COMPTYPE),PORTLAND)
 MPFC      = mpif90
 FFLAGS	 += -module $(OBJDIR) -fast
endif
ARCHIVE = ar r
MPLD=$(MPFC)


#precision switch

 ifeq ($(PRECISION),double)
   FFLAGS += -r8 -DDOUBLE_PREC 
 endif

###########################################################################
### Libraries                                                           ###
###########################################################################

LIBPATH = -L/usr/lib -L/usr/local/depot/openmpi-1.2.4/lib
LIBS = -lblas -lmpi -lmpi_f77

ifeq ($(FFTLIB),fftw)
LIBPATH += -L/home/fmerz/libraries/fftw/fftw-3.1.2/lib
LIBS	+= -lfftw3 -lfftw3f
endif

###########################################################################
### Linking                                                             ###
###########################################################################

include $(FFILES)

#------------------ mpirun ----------------------
run:	$(EXECDIR)/$(EXEC)
	ulimit -s unlimited;\
	cd $(RUNDIR);\
	mpirun -np $(N_PES) $(EXEC) 

###########################################################################
### Machine dependent compiling rules                                   ###
###########################################################################

