#!/bin/sh
# @ job_name            = GENE
# @ output              = $(job_name).$(jobid).out
# @ error               = $(job_name).$(jobid).err
# @ job_type            = bluegene
# @ environment         = COPY_ALL
# @ wall_clock_limit    = 02:00:00
# @ notification        = always
# @ notify_user         = <insert mail address>
## each midplane contains 512 cores (= 2048 processors in VN mode)
# @ bg_shape            = 2x4x4
# @ bg_rotate           = FALSE
# @ bg_connection       = TORUS
# @ queue

# a mapfile has to be produced with optimize_mapfile.py
# the maximal shape of the jugene is 9x4x4 which is 144 midplanes a 512 cores
# bg_rotate = FALSE does fix the given shape

mpirun -mode VN -mapfile ./mapfile.map -exe ./gene_jugene -env "BG_COREDUMPDISABLED=1 MEMORY_PER_CORE=450"














