#!/bin/bash
### batch jobs run in /bin/bash per default
###
### check 'man qsub' for all available options
###
### job has the same environmnent variables as 
### the submission shell (currently disabled)
###$ -V
### join stdout and stderr
#$ -j y
### start the job in the current working dir
#$ -cwd
### send notification (on (a)bort, (b)egin, (e)nd, (n)ever)
#$ -m n
###
#PBS -l size=12,walltime=00:15:00

#module load impi intel mkl fftw petsc slepc
module load fftw

export OMP_NUM_THREADS=1

### set MKL to serial mode
#export MKL_SERIAL=yes

### enable/disable Shared Receive Queue
### (currently we observe sporadical hang-ups if enabled)
#export MV2_USE_SRQ=0

### uncomment the following three lines if MPI memory error occur
#export MPICH_MAX_SHORT_MSG_SIZE=50000
#export MPICH_PTL_UNEX_EVENTS=80000
#export MPICH_UNEX_BUFFER_SIZE=1000M

cd $PBS_O_WORKDIR
aprun -n 12 ./gene_kraken_xt5

### to submit a parameter scan, comment the previous line and uncomment
### the following (see GENE documentation or ./scanscript --help)
#./scanscript --np 12 --ppn 1 --mps 4
