#!/bin/tcsh
#
# request Bourne shell as shell for job
#$ -S /bin/tcsh
#
# Change to the current working directory upon starting of the job
#$ -cwd
#
# join the error and standard output streams
#$ -j y
#
# set the required cpu time of your job
#$ -l h_cpu=00:05:00
#
# parallel environment; available queues are:
# mpich_tok_short (short runs)
# mpich_tok_devel (test runs)
# mpich_tok_production (use this for standard GENE runs)
#
#$ -pe mpich_tok_short 4
#
# don't flood myself with e-mail
#$ -m e
#
# this is my e-mail address
#$ -M $(USER)@ipp.mpg.de
#
# notify me about pending SIG_STOP and SIG_KILL
#$ -notify
#
# name of the job
#$ -N GENE
#
# important information:
# set stack limit to 100M by calling 
# limit stacksize 100M in your .cshrc

/afs/ipp/@sys/bin/mpirun -np 4 gene_tok_cluster

### to submit a parameter scan, comment the previous line and uncomment
### the following (see GENE documentation or ./scanscript --help)
#./scanscript --np 4 --ppn 4 --mps 4
